package drawingDemo;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import static java.lang.Math.*;

public class DrawingBox2D extends javax.swing.JPanel
implements MouseListener, MouseMotionListener
{

    private int degrees = 0;
    private FrameDemo2D mWindow;
    private Color backgroundColor;

    /**
     * Creates new form DrawingBox2D
     */
    public DrawingBox2D() {
        initComponents();
        addMouseMotionListener( this );
        addMouseListener( this );
    }

    // MouseListener implementation
    @Override
    public void mousePressed(MouseEvent evt) {
        backgroundColor = getBackground();
        setBackground( Color.GREEN );
        repaint();
    }

    @Override
    public void mouseReleased(MouseEvent evt) {
        setBackground( backgroundColor );
        repaint();
    }

    @Override
    public void mouseEntered(MouseEvent evt) {
    }

    @Override
    public void mouseExited(MouseEvent evt) {
    }

    @Override
    public void mouseClicked(MouseEvent evt) {
        // the mouse coordinates are
        // evt.getX()
        // evt.getY()
    }
    
    // MouseMotionListener implementation
    @Override
    public void mouseMoved(MouseEvent evt)
    {
        // the mouse coordinates are
        // evt.getX()
        // evt.getY()
    }

    @Override
    public void mouseDragged(MouseEvent e)
    {
    }    
    // operations
    // set window reference
    public void setWindow( FrameDemo2D window )
    {
        mWindow = window;
    }
    
    public void update() {
        degrees = (++degrees % 360 == 0) ? 0 : degrees;
    }

    @Override
    public void paintComponent(Graphics graph) {
        super.paintComponent(graph);

        // Our own 2D rendering starts here:
        graph.setColor(Color.RED);
        graph.fillRect(10, 20, 20, 40);
        graph.setColor(Color.BLUE);
        graph.drawString( "degrees=" + degrees, 35, 45);
        graph.drawLine(100, 100, 80, 80);

        // draw x axis
        graph.setColor(Color.GREEN);
        graph.drawLine(0, 100, 1000, 100);

        // draw sine
        graph.setColor(Color.BLUE);
        int oldx = 0;
        int oldy = 0;
        for (int x = 0; x < 360; ++x) {
            int y = (int)( -sin( Math.toRadians(x + degrees) ) * 50 ) + 100;
            //int y = (int)( -cos( Math.toRadians(x) ) * 50 ) + 100;
            //int y = (int)( -tan( Math.toRadians(x) ) * 50 ) + 100;
            //int y = (int) (-1 / tan(Math.toRadians(x + degrees)) * 50) + 100;
            graph.drawLine(oldx, oldy, x, y);
            oldx = x;
            oldy = y;
        }
    }//paintComponent

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
